diff -Naur usbip-0.1.4/src/lib/stub_driver.c trunk/src/lib/stub_driver.c
--- usbip-0.1.4/src/lib/stub_driver.c	2007-05-18 11:10:09.000000000 +0200
+++ trunk/src/lib/stub_driver.c	2007-05-18 11:10:07.000000000 +0200
@@ -1,5 +1,5 @@
 /*
- * Copyright (C) 2005-2006 Takahiro Hirofuchi
+ * Copyright (C) 2005-2007 Takahiro Hirofuchi
  */
 
 #include "usbip.h"
@@ -7,6 +7,7 @@
 static const char *usbip_stub_driver_name = "usbip";
 
 
+struct usbip_stub_driver *stub_driver;
 
 static struct sysfs_driver *open_sysfs_stub_driver(void)
 {
@@ -18,7 +19,7 @@
 
 
 	ret = sysfs_get_mnt_path(sysfs_mntpath, SYSFS_PATH_MAX);
-	if(ret < 0) {
+	if (ret < 0) {
 		err("sysfs must be mounted");
 		return NULL;
 	}
@@ -28,7 +29,7 @@
 			usbip_stub_driver_name);
 
 	stub_driver = sysfs_open_driver_path(stub_driver_path);
-	if(!stub_driver) {
+	if (!stub_driver) {
 		err("stub.ko must be loaded");
 		return NULL;
 	}
@@ -36,19 +37,6 @@
 	return stub_driver;
 }
 
-#if 0
-static void unshift_if_new(struct dlist *dlist, struct sysfs_device *target)
-{
-	struct sysfs_device *dev;
-
-	dlist_for_each_data(dlist, dev, struct sysfs_device) {
-		if(!strncmp(dev->bus_id, target->bus_id, SYSFS_BUS_ID_SIZE))
-			return;
-	}
-
-	dlist_unshift(dlist, (void *) target);
-}
-#endif
 
 
 /* only the first interface value is true! */
@@ -61,17 +49,17 @@
 
 	snprintf(attrpath, SYSFS_PATH_MAX, "%s/%s:%d.%d/usbip_status",
 			udev->path, udev->busid,
-			udev->bConfigurationValue, 
+			udev->bConfigurationValue,
 			0);
 
 	attr = sysfs_open_attribute(attrpath);
-	if(!attr) {
+	if (!attr) {
 		err("open %s", attrpath);
 		return -1;
 	}
 
 	ret = sysfs_read_attribute(attr);
-	if(ret) {
+	if (ret) {
 		err("read %s", attrpath);
 		sysfs_close_attribute(attr);
 		return -1;
@@ -87,7 +75,7 @@
 
 static void usbip_exported_device_delete(void *dev)
 {
-	struct usbip_exported_device *edev = 
+	struct usbip_exported_device *edev =
 		(struct usbip_exported_device *) dev;
 
 	sysfs_close_device(edev->sudev);
@@ -100,13 +88,13 @@
 	struct usbip_exported_device *edev = NULL;
 
 	edev = (struct usbip_exported_device *) calloc(1, sizeof(*edev));
-	if(!edev) {
+	if (!edev) {
 		err("alloc device");
 		return NULL;
 	}
 
 	edev->sudev = sysfs_open_device_path(sdevpath);
-	if(!edev->sudev) {
+	if (!edev->sudev) {
 		err("open %s", sdevpath);
 		goto err;
 	}
@@ -114,26 +102,26 @@
 	read_usb_device(edev->sudev, &edev->udev);
 
 	edev->status = read_attr_usbip_status(&edev->udev);
-	if(edev->status < 0) 
+	if (edev->status < 0)
 		goto err;
 
 	/* reallocate buffer to include usb interface data */
 	size_t size = sizeof(*edev) + edev->udev.bNumInterfaces * sizeof(struct usb_interface);
 	edev = (struct usbip_exported_device *) realloc(edev, size);
-	if(!edev) {
+	if (!edev) {
 		err("alloc device");
 		goto err;
 	}
 
-	for(int i=0; i < edev->udev.bNumInterfaces; i++)
+	for (int i=0; i < edev->udev.bNumInterfaces; i++)
 		read_usb_interface(&edev->udev, i, &edev->uinf[i]);
 
 	return edev;
 
 err:
-	if(edev && edev->sudev)
+	if (edev && edev->sudev)
 		sysfs_close_device(edev->sudev);
-	if(edev)
+	if (edev)
 		free(edev);
 	return NULL;
 }
@@ -144,7 +132,7 @@
 	struct sysfs_device *dev;
 
 	dlist_for_each_data(dlist, dev, struct sysfs_device) {
-		if(!strncmp(dev->bus_id, target->bus_id, SYSFS_BUS_ID_SIZE))
+		if (!strncmp(dev->bus_id, target->bus_id, SYSFS_BUS_ID_SIZE))
 			/* found. not new */
 			return 0;
 	}
@@ -157,19 +145,19 @@
 	/* do not delete anything. but, its container will be deleted. */
 }
 
-static int refresh_exported_devices(struct usbip_stub_driver *driver)
+static int refresh_exported_devices(void)
 {
 	struct sysfs_device	*suinf;  /* sysfs_device of usb_interface */
 	struct dlist		*suinf_list;
 
 	struct sysfs_device	*sudev;  /* sysfs_device of usb_device */
-	struct dlist		*sudev_list; 
+	struct dlist		*sudev_list;
 
 
 	sudev_list = dlist_new_with_delete(sizeof(struct sysfs_device), delete_nothing);
 
-	suinf_list = sysfs_get_driver_devices(driver->sysfs_driver);
-	if(!suinf_list) {
+	suinf_list = sysfs_get_driver_devices(stub_driver->sysfs_driver);
+	if (!suinf_list) {
 		printf("Bind usbip.ko to a usb device to be exportable!\n");
 		goto bye;
 	}
@@ -179,27 +167,27 @@
 
 		/* get usb device of this usb interface */
 		sudev = sysfs_get_device_parent(suinf);
-		if(!sudev) {
+		if (!sudev) {
 			err("get parent dev of %s", suinf->name);
 			continue;
-		} 
+		}
 
-		if(check_new(sudev_list, sudev)) {
+		if (check_new(sudev_list, sudev)) {
 			dlist_unshift(sudev_list, sudev);
 		}
 	}
 
 	dlist_for_each_data(sudev_list, sudev, struct sysfs_device) {
-		struct usbip_exported_device *edev; 
+		struct usbip_exported_device *edev;
 
 		edev = usbip_exported_device_new(sudev->path);
-		if(!edev) {
+		if (!edev) {
 			err("usbip_exported_device new");
 			continue;
 		}
 
-		dlist_unshift(driver->edev_list, (void *) edev);
-		driver->ndevs++;
+		dlist_unshift(stub_driver->edev_list, (void *) edev);
+		stub_driver->ndevs++;
 	}
 
 
@@ -210,91 +198,95 @@
 	return 0;
 }
 
-int usbip_stub_refresh_device_list(struct usbip_stub_driver *driver)
+int usbip_stub_refresh_device_list(void)
 {
 	int ret;
 
-	if(driver->edev_list)
-		dlist_destroy(driver->edev_list);
+	if (stub_driver->edev_list)
+		dlist_destroy(stub_driver->edev_list);
 
-	driver->ndevs = 0;
+	stub_driver->ndevs = 0;
 
-	driver->edev_list = dlist_new_with_delete(sizeof(struct usbip_exported_device),
+	stub_driver->edev_list = dlist_new_with_delete(sizeof(struct usbip_exported_device),
 			usbip_exported_device_delete);
-	if(!driver->edev_list) {
+	if (!stub_driver->edev_list) {
 		err("alloc dlist");
 		return -1;
 	}
 
-	ret = refresh_exported_devices(driver);
-	if(ret < 0) 
+	ret = refresh_exported_devices();
+	if (ret < 0)
 		return ret;
 
 	return 0;
 }
 
-struct usbip_stub_driver *usbip_stub_driver_open(void)
+int usbip_stub_driver_open(void)
 {
 	int ret;
-	struct usbip_stub_driver *driver;
 
-	
-	driver = (struct usbip_stub_driver *) calloc(1, sizeof(*driver));
-	if(!driver) {
-		err("alloc driver");
-		return NULL;
+
+	stub_driver = (struct usbip_stub_driver *) calloc(1, sizeof(*stub_driver));
+	if (!stub_driver) {
+		err("alloc stub_driver");
+		return -1;
 	}
 
-	driver->ndevs = 0;
+	stub_driver->ndevs = 0;
 
-	driver->edev_list = dlist_new_with_delete(sizeof(struct usbip_exported_device),
+	stub_driver->edev_list = dlist_new_with_delete(sizeof(struct usbip_exported_device),
 			usbip_exported_device_delete);
-	if(!driver->edev_list) {
+	if (!stub_driver->edev_list) {
 		err("alloc dlist");
 		goto err;
 	}
 
-	driver->sysfs_driver = open_sysfs_stub_driver();
-	if(!driver->sysfs_driver)
+	stub_driver->sysfs_driver = open_sysfs_stub_driver();
+	if (!stub_driver->sysfs_driver)
 		goto err;
 
-	ret = refresh_exported_devices(driver);
-	if(ret < 0) 
+	ret = refresh_exported_devices();
+	if (ret < 0)
 		goto err;
 
-	return driver;
+	return 0;
 
 
 err:
-	if(driver->sysfs_driver)
-		sysfs_close_driver(driver->sysfs_driver);
-	if(driver->edev_list)
-		dlist_destroy(driver->edev_list);
-	free(driver);
+	if (stub_driver->sysfs_driver)
+		sysfs_close_driver(stub_driver->sysfs_driver);
+	if (stub_driver->edev_list)
+		dlist_destroy(stub_driver->edev_list);
+	free(stub_driver);
 
-	return NULL;
+	stub_driver = NULL;
+	return -1;
 }
 
 
-void usbip_stub_driver_close(struct usbip_stub_driver *driver)
+void usbip_stub_driver_close(void)
 {
-	if(driver->edev_list)
-		dlist_destroy(driver->edev_list);
-	if(driver->sysfs_driver)
-		sysfs_close_driver(driver->sysfs_driver);
-	free(driver);
+	if (!stub_driver)
+		return;
+
+	if (stub_driver->edev_list)
+		dlist_destroy(stub_driver->edev_list);
+	if (stub_driver->sysfs_driver)
+		sysfs_close_driver(stub_driver->sysfs_driver);
+	free(stub_driver);
+
+	stub_driver = NULL;
 }
 
-int usbip_stub_export_device(struct usbip_stub_driver *driver,
-		struct usbip_exported_device *edev, int sockfd)
+int usbip_stub_export_device(struct usbip_exported_device *edev, int sockfd)
 {
 	char attrpath[SYSFS_PATH_MAX];
 	struct sysfs_attribute *attr;
 	char sockfd_buff[30];
-	int ret; 
+	int ret;
 
 
-	if(edev->status != SDEV_ST_AVAILABLE) {
+	if (edev->status != SDEV_ST_AVAILABLE) {
 		info("device not available, %s", edev->udev.busid);
 		return -1;
 	}
@@ -307,7 +299,7 @@
 			"usbip_sockfd");
 
 	attr = sysfs_open_attribute(attrpath);
-	if(!attr) {
+	if (!attr) {
 		err("open %s", attrpath);
 		return -1;
 	}
@@ -317,7 +309,7 @@
 	dbg("write: %s", sockfd_buff);
 
 	ret = sysfs_write_attribute(attr, sockfd_buff, strlen(sockfd_buff));
-	if(ret < 0) {
+	if (ret < 0) {
 		err("write sockfd %s to %s", sockfd_buff, attrpath);
 		goto err_write_sockfd;
 	}
@@ -330,15 +322,14 @@
 	return ret;
 }
 
-struct usbip_exported_device *usbip_stub_get_device(struct usbip_stub_driver *driver,
-		int num)
+struct usbip_exported_device *usbip_stub_get_device(int num)
 {
-	struct usbip_exported_device *edev; 
-	struct dlist		*dlist = driver->edev_list;
+	struct usbip_exported_device *edev;
+	struct dlist		*dlist = stub_driver->edev_list;
 	int count = 0;
 
 	dlist_for_each_data(dlist, edev, struct usbip_exported_device) {
-		if(num == count)
+		if (num == count)
 			return edev;
 		else
 			count++ ;
diff -Naur usbip-0.1.4/src/lib/stub_driver.h trunk/src/lib/stub_driver.h
--- usbip-0.1.4/src/lib/stub_driver.h	1970-01-01 01:00:00.000000000 +0100
+++ trunk/src/lib/stub_driver.h	2007-05-18 11:10:07.000000000 +0200
@@ -0,0 +1,36 @@
+/*
+ * Copyright (C) 2005-2007 Takahiro Hirofuchi
+ */
+
+#ifndef _USBIP_STUB_DRIVER_H
+#define _USBIP_STUB_DRIVER_H
+
+#include "usbip.h"
+
+
+struct usbip_stub_driver {
+	int ndevs;
+	struct sysfs_driver *sysfs_driver;
+
+	struct dlist *edev_list;	/* list of exported device */
+};
+
+struct usbip_exported_device {
+	struct sysfs_device *sudev;
+
+	int32_t status;
+	struct usb_device    udev;
+	struct usb_interface uinf[];
+};
+
+
+extern struct usbip_stub_driver *stub_driver;
+
+int usbip_stub_driver_open(void);
+void usbip_stub_driver_close(void);
+
+int usbip_stub_refresh_device_list(void);
+int usbip_stub_export_device(struct usbip_exported_device *edev, int sockfd);
+
+struct usbip_exported_device *usbip_stub_get_device(int num);
+#endif
diff -Naur usbip-0.1.4/src/lib/usbip_common.c trunk/src/lib/usbip_common.c
--- usbip-0.1.4/src/lib/usbip_common.c	2007-05-18 11:10:09.000000000 +0200
+++ trunk/src/lib/usbip_common.c	2007-05-18 11:10:07.000000000 +0200
@@ -1,8 +1,9 @@
 /*
- * Copyright (C) 2005-2006 Takahiro Hirofuchi
+ * Copyright (C) 2005-2007 Takahiro Hirofuchi
  */
 
 #include "usbip.h"
+#include "names.h"
 
 int usbip_use_syslog = 0;
 int usbip_use_stderr = 0;
@@ -40,8 +41,8 @@
 
 const char *usbip_status_string(int32_t status)
 {
-	for(int i=0; portst_strings[i].desc != NULL; i++) 
-		if(portst_strings[i].num == status)
+	for (int i=0; portst_strings[i].desc != NULL; i++)
+		if (portst_strings[i].num == status)
 			return portst_strings[i].desc;
 
 	return "Unknown Status";
@@ -49,53 +50,13 @@
 
 const char *usbip_speed_string(int num)
 {
-	for(int i=0; speed_strings[i].speed != NULL; i++) 
-		if(speed_strings[i].num == num)
+	for (int i=0; speed_strings[i].speed != NULL; i++)
+		if (speed_strings[i].num == num)
 			return speed_strings[i].desc;
 
 	return "Unknown Speed";
 }
 
-void pack_uint32_t(int pack, uint32_t *num)
-{
-	uint32_t i;
-
-	if(pack)
-		i = htonl(*num);
-	else
-		i = ntohl(*num);
-
-	*num = i;
-}
-
-void pack_uint16_t(int pack, uint16_t *num)
-{
-	uint16_t i;
-
-	if(pack)
-		i = htons(*num);
-	else
-		i = ntohs(*num);
-
-	*num = i;
-}
-
-void pack_usb_device(int pack, struct usb_device *udev)
-{
-	pack_uint32_t(pack, &udev->busnum);
-	pack_uint32_t(pack, &udev->devnum);
-	pack_uint32_t(pack, &udev->speed );
-
-	pack_uint16_t(pack, &udev->idVendor );
-	pack_uint16_t(pack, &udev->idProduct);
-	pack_uint16_t(pack, &udev->bcdDevice);
-}
-
-void pack_usb_interface(int pack, struct usb_interface *udev)
-{
-	/* uint8_t members need nothing */
-}
-
 
 #define DBG_UDEV_INTEGER(name)\
 	dbg("%-20s = %x", to_string(name), (int) udev->name)
@@ -106,7 +67,7 @@
 void dump_usb_interface(struct usb_interface *uinf)
 {
 	char buff[100];
-	usbip_class_name(buff, sizeof(buff),
+	usbip_names_get_class(buff, sizeof(buff),
 			uinf->bInterfaceClass,
 			uinf->bInterfaceSubClass,
 			uinf->bInterfaceProtocol);
@@ -121,7 +82,7 @@
 	dbg("%-20s = %s", "path",  udev->path);
 	dbg("%-20s = %s", "busid", udev->busid);
 
-	usbip_class_name(buff, sizeof(buff),
+	usbip_names_get_class(buff, sizeof(buff),
 			udev->bDeviceClass,
 			udev->bDeviceSubClass,
 			udev->bDeviceProtocol);
@@ -129,7 +90,7 @@
 
 	DBG_UDEV_INTEGER(bcdDevice);
 
-	usbip_product_name(buff, sizeof(buff),
+	usbip_names_get_product(buff, sizeof(buff),
 			udev->idVendor,
 			udev->idProduct);
 	dbg("%-20s = %s", "Vendor/Product", buff);
@@ -137,7 +98,7 @@
 	DBG_UDEV_INTEGER(bNumConfigurations);
 	DBG_UDEV_INTEGER(bNumInterfaces);
 
-	dbg("%-20s = %s", "speed", 
+	dbg("%-20s = %s", "speed",
 			usbip_speed_string(udev->speed));
 
 	DBG_UDEV_INTEGER(busnum);
@@ -155,19 +116,19 @@
 	snprintf(attrpath, sizeof(attrpath), "%s/%s", dev->path, name);
 
 	attr = sysfs_open_attribute(attrpath);
-	if(!attr) {
+	if (!attr) {
 		err("open attr %s", attrpath);
 		return 0;
 	}
 
 	ret = sysfs_read_attribute(attr);
-	if(ret < 0) {
+	if (ret < 0) {
 		err("read attr");
 		goto err;
 	}
 
 	ret = sscanf(attr->value, format, &num);
-	if(ret < 1) {
+	if (ret < 1) {
 		err("sscanf");
 		goto err;
 	}
@@ -189,27 +150,27 @@
 	snprintf(attrpath, sizeof(attrpath), "%s/%s", dev->path, "speed");
 
 	attr = sysfs_open_attribute(attrpath);
-	if(!attr) {
+	if (!attr) {
 		err("open attr");
 		return 0;
 	}
 
 	ret = sysfs_read_attribute(attr);
-	if(ret < 0) {
+	if (ret < 0) {
 		err("read attr");
 		goto err;
 	}
 
 	ret = sscanf(attr->value, "%s\n", speed);
-	if(ret < 1) {
+	if (ret < 1) {
 		err("sscanf");
 		goto err;
 	}
 err:
 	sysfs_close_attribute(attr);
 
-	for(int i=0; speed_strings[i].speed != NULL; i++) {
-		if(!strcmp(speed, speed_strings[i].speed))
+	for (int i=0; speed_strings[i].speed != NULL; i++) {
+		if (!strcmp(speed, speed_strings[i].speed))
 			return speed_strings[i].num;
 	}
 
@@ -217,7 +178,7 @@
 }
 
 #define READ_ATTR(object, type, dev, name, format)\
-	do { (object)->name = (type) read_attr_value(dev, to_string(name), format); } while(0)
+	do { (object)->name = (type) read_attr_value(dev, to_string(name), format); } while (0)
 
 
 int read_usb_device(struct sysfs_device *sdev, struct usb_device *udev)
@@ -256,7 +217,7 @@
 	sprintf(busid, "%s:%d.%d", udev->busid, udev->bConfigurationValue, i);
 
 	sif = sysfs_open_device("usb", busid);
-	if(!sif) {
+	if (!sif) {
 		err("open sif of %s", busid);
 		return -1;
 	}
@@ -270,24 +231,33 @@
 	return 0;
 }
 
+int usbip_names_init(char *f)
+{
+	return names_init(f);
+}
+
+void usbip_names_free()
+{
+	names_free();
+}
 
-void usbip_product_name(char *buff, size_t size, uint16_t vendor, uint16_t product)
+void usbip_names_get_product(char *buff, size_t size, uint16_t vendor, uint16_t product)
 {
 	const char *prod, *vend;
 
 	prod = names_product(vendor, product);
-	if(!prod)
+	if (!prod)
 		prod = "unknown product";
 
 
 	vend = names_vendor(vendor);
-	if(!vend)
+	if (!vend)
 		vend = "unknown vendor";
 
 	snprintf(buff, size, "%s : %s (%04x:%04x)", vend, prod, vendor, product);
 }
 
-void usbip_class_name(char *buff, size_t size, uint8_t class, uint8_t subclass, uint8_t protocol)
+void usbip_names_get_class(char *buff, size_t size, uint8_t class, uint8_t subclass, uint8_t protocol)
 {
 	const char *c, *s, *p;
 
@@ -297,15 +267,15 @@
 	}
 
 	p = names_protocol(class, subclass, protocol);
-	if(!p)
+	if (!p)
 		p = "unknown protocol";
 
 	s = names_subclass(class, subclass);
-	if(!s)
+	if (!s)
 		s = "unknown subclass";
 
 	c = names_class(class);
-	if(!c)
+	if (!c)
 		c = "unknown class";
 
 	snprintf(buff, size, "%s / %s / %s (%02x/%02x/%02x)", c, s, p, class, subclass, protocol);
diff -Naur usbip-0.1.4/src/lib/usbip_common.h trunk/src/lib/usbip_common.h
--- usbip-0.1.4/src/lib/usbip_common.h	1970-01-01 01:00:00.000000000 +0100
+++ trunk/src/lib/usbip_common.h	2007-05-18 11:10:07.000000000 +0200
@@ -0,0 +1,144 @@
+/*
+ * Copyright (C) 2005-2007 Takahiro Hirofuchi
+ */
+
+#ifndef _USBIP_COMMON_H
+#define _USBIP_COMMON_H
+
+#include <unistd.h>
+#include <stdint.h>
+#include <syslog.h>
+#include <errno.h>
+#include <stdio.h>
+#include <string.h>
+#include <stdlib.h>
+#include <strings.h>
+
+#include <sysfs/libsysfs.h>
+#include <netdb.h>
+#include <sys/socket.h>
+
+#ifndef USBIDS_FILE
+#define USBIDS_FILE "/usr/share/hwdata/usb.ids"
+#endif
+
+extern int usbip_use_syslog;
+extern int usbip_use_stderr;
+extern int usbip_use_debug ;
+
+//#include <linux/usb_ch9.h>
+enum usb_device_speed {
+	USB_SPEED_UNKNOWN = 0,                  /* enumerating */
+	USB_SPEED_LOW, USB_SPEED_FULL,          /* usb 1.1 */
+	USB_SPEED_HIGH,                         /* usb 2.0 */
+	USB_SPEED_VARIABLE                      /* wireless (usb 2.5) */
+};
+
+/* FIXME: how to sync with drivers/usbip_common.h ? */
+enum usbip_device_status{
+	/* sdev is available. */
+	SDEV_ST_AVAILABLE = 0x01,
+	/* sdev is now used. */
+	SDEV_ST_USED,
+	/* sdev is unusable because of a fatal error. */
+	SDEV_ST_ERROR,
+
+	/* vdev does not connect a remote device. */
+	VDEV_ST_NULL,
+	/* vdev is used, but the USB address is not assigned yet */
+	VDEV_ST_NOTASSIGNED,
+	VDEV_ST_USED,
+	VDEV_ST_ERROR
+};
+
+#define err(fmt, args...)	do { \
+	if (usbip_use_syslog) { \
+		syslog(LOG_ERR, "usbip err: %13s:%4d (%-12s) " fmt "\n", \
+			__FILE__, __LINE__, __FUNCTION__,  ##args); \
+	} \
+	if (usbip_use_stderr) { \
+		fprintf(stderr, "usbip err: %13s:%4d (%-12s) " fmt "\n", \
+			__FILE__, __LINE__, __FUNCTION__,  ##args); \
+	} \
+} while (0)
+
+#define notice(fmt, args...)	do { \
+	if (usbip_use_syslog) { \
+		syslog(LOG_DEBUG, "usbip: " fmt, ##args); \
+	} \
+	if (usbip_use_stderr) { \
+		fprintf(stderr, "usbip: " fmt "\n",  ##args); \
+	} \
+} while (0)
+
+#define info(fmt, args...)	do { \
+	if (usbip_use_syslog) { \
+		syslog(LOG_DEBUG, fmt, ##args); \
+	} \
+	if (usbip_use_stderr) { \
+		fprintf(stderr, fmt "\n",  ##args); \
+	} \
+} while (0)
+
+#define dbg(fmt, args...)	do { \
+	if (usbip_use_debug) { \
+		if (usbip_use_syslog) { \
+			syslog(LOG_DEBUG, "usbip dbg: %13s:%4d (%-12s) " fmt, \
+				__FILE__, __LINE__, __FUNCTION__,  ##args); \
+		} \
+		if (usbip_use_stderr) { \
+			fprintf(stderr, "usbip dbg: %13s:%4d (%-12s) " fmt "\n", \
+				__FILE__, __LINE__, __FUNCTION__,  ##args); \
+		} \
+	} \
+} while (0)
+
+
+#define BUG()	do { err("sorry, it's a bug"); abort(); } while (0)
+
+struct usb_interface {
+	uint8_t bInterfaceClass;
+	uint8_t bInterfaceSubClass;
+	uint8_t bInterfaceProtocol;
+	uint8_t padding;	/* alignment */
+} __attribute__((packed));
+
+
+
+struct usb_device {
+	char path[SYSFS_PATH_MAX];
+	char busid[SYSFS_BUS_ID_SIZE];
+
+	uint32_t busnum;
+	uint32_t devnum;
+	uint32_t speed;
+
+	uint16_t idVendor;
+	uint16_t idProduct;
+	uint16_t bcdDevice;
+
+	uint8_t bDeviceClass;
+	uint8_t bDeviceSubClass;
+	uint8_t bDeviceProtocol;
+	uint8_t bConfigurationValue;
+	uint8_t bNumConfigurations;
+	uint8_t bNumInterfaces;
+} __attribute__((packed));
+
+#define to_string(s)	#s
+
+void dump_usb_interface(struct usb_interface *);
+void dump_usb_device(struct usb_device *);
+int read_usb_device(struct sysfs_device *sdev, struct usb_device *udev);
+int read_attr_value(struct sysfs_device *dev, const char *name, const char *format);
+int read_usb_interface(struct usb_device *udev, int i, struct usb_interface *uinf);
+
+const char *usbip_speed_string(int num);
+const char *usbip_status_string(int32_t status);
+
+int usbip_names_init(char *);
+void usbip_names_free(void);
+void usbip_names_get_product(char *buff, size_t size, uint16_t vendor, uint16_t product);
+void usbip_names_get_class(char *buff, size_t size, uint8_t class, uint8_t subclass, uint8_t protocol);
+
+#endif
diff -Naur usbip-0.1.4/src/lib/usbip.h trunk/src/lib/usbip.h
--- usbip-0.1.4/src/lib/usbip.h	1970-01-01 01:00:00.000000000 +0100
+++ trunk/src/lib/usbip.h	2007-05-18 11:10:07.000000000 +0200
@@ -0,0 +1,19 @@
+/*
+ * Copyright (C) 2005-2007 Takahiro Hirofuchi
+ */
+
+#ifndef _USBIP_H
+#define _USBIP_H
+
+#ifdef HAVE_CONFIG_H
+#include "../config.h"
+#endif
+
+#include "usbip_common.h"
+#include "stub_driver.h"
+#include "vhci_driver.h"
+#ifdef DMALLOC
+#include <dmalloc.h>
+#endif
+
+#endif
